VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Contour"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Number of tools in this server
Const NUM_TOOLS = 1
Public xcWorld As Double
Public ycWorld As Double


' *******************************************************************
'    Const EventMask = 268435456 + 536870912
'    Const EventMask = 1024 + 268435456 + 536870912
    Const EventMask = 1 + 2 + 4 + 8 + 16 + 32 + 64 + 1024 + 4096 + 262144 + 268435456 + 536870912

    Private iConnectId As Long
    Private iActTool As Long
    Private theToolEvents As IToolEvents


' *******************************************************************
'Toggle this to test loading buttons from .Bmp/.Res
Const boolLoadFromBmp As Boolean = False
Const boolDebug As Boolean = False
'##########################################################################
'##########################################################################
Private Declare Function TCWUndoClear Lib "TCAPI70.dll" () As Long
Private Declare Function TCWUndoRecordEnd Lib "TCAPI70.dll" (ByVal d As Long) As Long
Private Declare Function TCWUndoRecordStart Lib "TCAPI70.dll" (ByVal d As Long, ByRef Title As String) As Long
Private Declare Function TCWUndoRecordAddGraphic Lib "TCAPI70.dll" (ByVal d As Long, ByVal g As Long) As Long
Private Declare Function TCWUndo Lib "TCAPI70.dll" (ByVal N As Long) As Long

Private Declare Function TCWDrawingActive Lib "TCAPI70.dll" () As Long
Private Declare Function TCWGraphicAt Lib "TCAPI70.dll" (ByVal d As Long, ByVal Index As Long) As Long
Private Declare Function TCWVertexAt Lib "TCAPI70.dll" (ByVal g As Long, ByVal Index As Long) As Long

Private Declare Sub prVertexSetSomeFlags Lib "DBAPI70.dll" (ByVal hVer As Long, ByVal FlagOn As Long, ByVal FlagOff As Long)

Private Declare Function GraphicGetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long) As Long
Private Declare Function GraphicSetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long, ByVal hMat As Long) As Boolean
Private Declare Function MatrixEqual Lib "DBAPI70.dll" (ByVal hM1 As Long, ByVal hM2 As Long) As Boolean

Private Declare Function TCWViewRedraw Lib "TCAPI70.dll" () As Long

Private hDr As Long


'Copy a windows bitmap of the requested size to the clipboard
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire bitmap:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono bitmap should be 1-bit (black or white)
Public Function CopyBitmap(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Boolean
    On Error GoTo BitmapError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        'Put the image on the Windows clipboard
        Clipboard.SetData TheImage, vbCFDIB
        CopyBitmap = True
        Exit Function
    End If

BitmapError:
    CopyBitmap = False
End Function

'Return a Picture object for the requested size
'Apparently, returning references to StdPicture objects doesn't work for .EXE servers
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire image:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono image should be 1-bit (black or white)
Public Function GetPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Object
    On Error GoTo PictureError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        Set GetPicture = TheImage
        Exit Function
    End If

PictureError:
    Set GetPicture = Nothing
End Function

'Implementation specific stuff
'Private function to return the bitmap from .Res file or .Bmp file
Private Function GetButtonPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean, TheImage As StdPicture) As Boolean
    On Error GoTo LoadError

    'There are two ways to load images:  from .Bmp file(s) or from .RES resource.
    'In this demo, we control the loading by a private variable.
    
    'Note that if you are loading from .Bmp, or if you are running this tool as a
    '.VBP for debugging, you must place the .Res or .Bmp files in the Draggers subdirectory
    'of the directory in which TCW40.EXE (or IMSIGX40.DLL) is located.

    If boolLoadFromBmp Then
        'Load from .Bmp file
        Dim strFileName As String 'File name of .Bmp file to load

        If LargeImage Then
            strFileName = App.Path & "\button24.bmp"
        Else
            strFileName = App.Path & "\button16.bmp"
        End If
        Set TheImage = LoadPicture(strFileName)
    Else
        'Load from .Res file
        Dim idBitmap%  'BITMAP resource id in .Res file

        If LargeImage Then
            idBitmap% = 1002
        Else
            idBitmap% = 1001
        End If
        Set TheImage = LoadResPicture(idBitmap%, vbResBitmap)
    End If

    'Return the image
    GetButtonPicture = True
    Exit Function

LoadError:
    If boolDebug Then
'        MsgBox "Error loading bitmap: " & Err.Description
    End If
    GetButtonPicture = False
End Function


'##########################################################################
'##########################################################################
'##########################################################################


'Return a description string for this package of tools
Public Property Get Description() As String
    Description = "AddGearContour"
End Property

'Called to perform tool function
Public Function Run(ByVal Tool As Object) As Boolean
    On Error GoTo ErrorHandler
Dim theXTool As Tool
    Set theXTool = Tool
'    theXTool.Application.ActiveDrawing.Graphics.Unselect
    If iConnectId <> -1 Then
        objApp.DisconnectEvents iConnectId
        AddLM False
        iConnectId = -1
        iActTool = -1
        theToolEvents.ToolChangePrompt Me, "", False
    Else
        theToolEvents.ToolChangePrompt Me, "", False
        theToolEvents.ToolChangePrompt Me, "Input Data", False
        ParamCanc = True
        frmGearContour.Show 1
        If ParamCanc = True Then
            If iConnectId <> -1 Then
                theToolEvents.ToolChangePrompt Me, "", False
                objApp.DisconnectEvents iConnectId
                iConnectId = -1
                AddLM False
            End If
            Call Finish
            Exit Function
        End If
       iConnectId = objApp.ConnectEvents(Me, EventMask)
        iActTool = theXTool.Index
        AddLM True
        theToolEvents.ToolChangePrompt Me, "Click the cener of the Gear Contour", False
    End If
    Set ActDr = Tool.Application.ActiveDrawing
    Set Grs = ActDr.Graphics

'    Call GearContour
'    Call Finish
'    If iConnectId <> -1 Then
'        objApp.DisconnectEvents iConnectId
'        AddLM False
'        iConnectId = -1
'        iActTool = -1
'        theToolEvents.ToolChangePrompt Me, "", False
'    End If
    
    Exit Function
ErrorHandler:
'    MsgBox Err.Msg
    Call Finish
End Function




'Fill arrays with information about tools in the package
'Return the number of tools in the package
Public Function GetToolInfo(CommandNames As Variant, MenuCaptions As Variant, StatusPrompts As Variant, _
    ToolTips As Variant, Enabled As Variant, WantsUpdates As Variant) As Long

    ReDim CommandNames(NUM_TOOLS)
    ReDim MenuCaptions(NUM_TOOLS)
    ReDim StatusPrompts(NUM_TOOLS)
    ReDim ToolTips(NUM_TOOLS)
    ReDim Enabled(NUM_TOOLS)
    ReDim WantsUpdates(NUM_TOOLS)
    CommandNames(0) = "SDK|Gear Contour"
    MenuCaptions(0) = "&Gear Contour"
    ToolTips(0) = "Gear Contour"
    Enabled(0) = True
    WantsUpdates(0) = False
    GetToolInfo = NUM_TOOLS
End Function



'Returns true if tool is correctly initialized
Public Function Initialize(ByVal Tool As Object) As Boolean
On Error GoTo ErrorHandler
    Set objApp = Tool.Application
    Set theToolEvents = objApp
    iConnectId = -1
    iActTool = -1
    Initialize = True
    Exit Function
ErrorHandler:
 '   MsgBox Err.Description
End Function

'Returns true if tool is correctly initialized
Public Function UpdateToolStatus(ByVal Tool As Object, Enabled As Boolean, Checked As Boolean) As Boolean
    Enabled = True 'Could do a test here to determine whether to disable the button/menu item
    If iConnectId = -1 Then
        Checked = False  'Could do a test here to determine whether to check the button/menu item
    Else
        Checked = True
    End If
    UpdateToolStatus = True
End Function


Public Function RunTool(WhichTool As Tool)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function



Public Function BeforeExit(WhichApplication As Application, Cancel As Boolean)
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    Call Finish

End Function
Public Function DrawingNew(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    
    Call Finish
End Function
Public Function DrawingOpen(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingActivate(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingDeactivate(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingBeforeClose(WhichDrawing As Drawing, Cancel As Boolean)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingBeforeSave(WhichDrawing As Drawing, SaveAs As Boolean, Cancel As Boolean)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    Call Finish
End Function



Public Function MouseDown(WhichDrawing As Drawing, WhichView As View, WhichWindow As Window, Button As ImsiMouseButton, Shift As Long, x As Long, y As Long, Cancel As Boolean)
Dim xClick#, yClick#
On Error GoTo ErrorHandler
    Set Drs = objApp.Drawings
    Set ActDr = WhichDrawing
    Set Grs = ActDr.Graphics
    Set Vis = ActDr.Views
    Set Vi = WhichView
    hDr = TCWDrawingActive


    Vi.ScreenToView x, y, xClick, yClick
    Vi.ViewToWorld xClick, yClick, 0, xcWorld, ycWorld, 0
'MsgBox ("xcWorld=" & CStr(xcWorld) & "  ycWorld=" & CStr(ycWorld))
    
    If Button = imsiLeftButton Then
'        Cancel = True
 '       theToolEvents.ToolChangePrompt Me, "", False
'        Vi.Refresh
'        theToolEvents.ToolChangePrompt Me, "Pick any field of the Schedule", False
'    Else
'        Call GearContour
        Call TeethInvol
        Vi.ZoomToExtents
        If iConnectId <> -1 Then
            theToolEvents.ToolChangePrompt Me, "", False
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
            AddLM False
        End If
        Grs.Unselect
        Call Finish
        Cancel = False
    End If
'    Call Finish
    Exit Function
ErrorHandler:
    If iConnectId <> -1 Then
        theToolEvents.ToolChangePrompt Me, "", False
        objApp.DisconnectEvents iConnectId
        iConnectId = -1
        AddLM False
    End If
    Call Finish
 '   MsgBox Err.Description
End Function

Public Function Cancel(DoItPlease As Boolean, CanCancel As Boolean)
    If (DoItPlease) Then
        If iConnectId <> -1 Then
            theToolEvents.ToolChangePrompt Me, "", False
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
        End If
                
        theToolEvents.ToolChangePrompt Me, "", False
        Call Finish
    End If

    CanCancel = True
End Function

Public Function UpdateUndo(AllowsUndo As Boolean)
    AllowsUndo = False
End Function

Private Function AddActToolLM(iTool As Long, bAdd As Boolean)
'    AddLM bAdd
End Function
Private Sub Class_Terminate()
    If (Not theToolEvents Is Nothing) Then
        Set theToolEvents = Nothing
    End If
    If (Not objApp Is Nothing) Then
        Set objApp = Nothing
    End If
    
End Sub



Private Function AddLM(bAdd As Boolean)
Dim Captions(0 To 0) As String
Dim Prompts(0 To 0) As String
Dim Enabled(0 To 0) As Boolean
Dim Checked(0 To 0) As Boolean

Dim varCaptions As Variant
Dim varPrompts As Variant
Dim varEnabled As Variant
Dim varChecked As Variant

    If (bAdd) Then
        Captions(0) = "Finish GearContour"
        Prompts(0) = "Finish GearContour"
        Enabled(0) = True
        Checked(0) = True
        varCaptions = Captions
        varPrompts = Prompts
        varEnabled = Enabled
        varChecked = Checked
        
        theToolEvents.ToolChangeCommands Me, 1, varCaptions, varPrompts, varEnabled, varChecked, True
    Else
        theToolEvents.ToolChangeCommands Me, 0, , , , , False
    End If
End Function

Public Function DoLMCommand(CmdInd As Long)
'MsgBox ("CmdInd=" & CStr(CmdInd))
   If CmdInd = 0 Then
         If iConnectId <> -1 Then
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
            AddLM False
        End If
        theToolEvents.ToolChangePrompt Me, "", False
      
        Call Finish
'        Set objApp = Nothing
        
    End If

End Function
Private Sub Finish()
    Set Grs = Nothing
    Set Vi = Nothing
    Set Vis = Nothing
    Set ActDr = Nothing
    Set Drs = Nothing
 '   Set objApp = Nothing
End Sub






Private Sub GearContour()
Dim Gr As Graphic

Dim N% 'Number of Teeth
Dim Db# 'Base Circle Diameter
Dim D0# ' Outside Diameter
Dim Dr# ' Root Diameter
Dim d# 'Pitch Diameter
Dim a# 'Addendum
Dim b# 'Dedendum
Dim Pd# 'Diametral Pitch
Dim Pc# 'Circular Pitch
Dim ht# ' Whole Depth of Tooth
Dim tet# 'Pressure Angle
Dim GearWidth#
'    frmGearContour.Show 1
    N = CInt(frmGearContour.TeethCount.Text)
    If N < 8 Then N = 10
    If N > 30 Then N = 30
    Pd = CDbl(frmGearContour.DiamPitch.Text)
'    GearWidth = CDbl(UserForm1.GearWidth.Text)
    tet = CDbl(frmGearContour.PressureAngle.Text) / 180 * Pi

'    N = 20
'    Pd = 2
'    tet = 20 / 180 * Pi
    d = N / Pd
    Pc = Pi * d / N
    D0 = (N + 2) / Pd
    Db = d * Cos(tet)
    a = 0.3183 * Pc
    b = 0.3979 * Pc
    ht = a + b
    Dr = D0 - 2 * ht
Dim x0#, y0#, z0#
    x0 = 0
    y0 = 0
    z0 = 0
'Outside circle
'    Set Gr = Grs.AddCircleCenterAndPoint(x0, y0, z0, x0 + D0 / 2, y0, z0)
'    Gr.Properties("PenColor") = RGB(0, 255, 0)
'    Gr.Properties("PenStyle") = "DASHED"
    
'Inside Circle
'    Set Gr = Grs.AddCircleCenterAndPoint(x0, y0, z0, x0 + Dr / 2, y0, z0)
'    Gr.Properties("PenColor") = RGB(0, 255, 0)
'    Gr.Properties("PenStyle") = "DASHED"
'Base Circle
'    Set Gr = Grs.AddCircleCenterAndPoint(x0, y0, z0, x0 + Db / 2, y0, z0)
'    Gr.Properties("PenColor") = RGB(255, 0, 0)
'    Gr.Properties("PenStyle") = "DASHED"
'Pitch Circle
'    Set Gr = Grs.AddCircleCenterAndPoint(x0, y0, z0, x0 + d / 2, y0, z0)
'    Gr.Properties("PenColor") = RGB(0, 0, 255)
'    Gr.Properties("PenStyle") = "DASHED"

    If Db < Dr Then Db = 1.01 * Dr
    
' First side of the tooth
Dim St# 'Circular Tooth Thickness
Dim Et# 'Circular Hole Thickness
    St = 1.53 / Pi * Pc ' Fot Internal Gears
'    St = 1.61159 / Pi * Pc ' Fot External Gears
    Et = Pc - St
    
Dim fi#, dfi#, fia#, xa#, ya#
    fi = 0
    dfi = St / (d / 2)
    fia = fi + dfi / 2
    xa = x0 + d / 2 * Cos(dfi / 2)
    ya = y0 + d / 2 * Sin(dfi / 2)
    
Dim xc#, yc#, R#
    R = d / 6
Dim lcc#, sina#, cosa#
    lcc = Sqr((x0 - xa) * (x0 - xa) + (y0 - ya) * (y0 - ya))
    sina = (ya - y0) / lcc
    cosa = (xa - x0) / lcc
Dim CosAlp#
    CosAlp = (lcc * lcc + Db * Db / 4 - R * R) / (2 * lcc * Db / 2)
Dim xlocint#, ylocint#
    xlocint = Db / 2 * CosAlp
    ylocint = -Db / 2 * Sqr(1 - CosAlp * CosAlp)
Dim xint#, yint#
    xint = x0 + xlocint * cosa - ylocint * sina
    yint = y0 + xlocint * sina + ylocint * cosa
    
' Point on Outside circle
    lcc = Db / 2
    sina = (yint - y0) / lcc
    cosa = (xint - x0) / lcc
    CosAlp = (D0 * D0 / 4 + Db * Db / 4 - R * R) / (2 * D0 / 2 * Db / 2)
    xlocint = D0 / 2 * CosAlp
    ylocint = D0 / 2 * Sqr(1 - CosAlp * CosAlp)
Dim xInt1#, yInt1#
    xInt1 = x0 + xlocint * cosa - ylocint * sina
    yInt1 = y0 + xlocint * sina + ylocint * cosa
'Set Gr = Grs.AddStar(xint1, yint1, 0)

' Point on Base circle

    sina = (yint - y0) / lcc
    cosa = (xint - x0) / lcc
    CosAlp = (Db * Db / 4 + Db * Db / 4 - R * R) / (2 * Db / 2 * Db / 2)
    xlocint = Db / 2 * CosAlp
    ylocint = Db / 2 * Sqr(1 - CosAlp * CosAlp)
Dim xInt2#, yInt2#
    xInt2 = x0 + xlocint * cosa - ylocint * sina
    yInt2 = y0 + xlocint * sina + ylocint * cosa
'Set Gr = Grs.AddStar(xint2, yint2, 0)


'add evolvente curve as arc
Dim GrTeeth As Graphic
    Set GrTeeth = Grs.Add(11)
Dim Gr1 As Graphic
    Set Gr1 = GrTeeth.Graphics.AddArcTriplePoint(xInt1, yInt1, 0, xa, ya, 0, xInt2, yInt2, 0)
    GrTeeth.Graphics.Remove Gr1.Index
    Grs.AddGraphic Gr1
'Add the line segment
Dim TanAlp#, alp
    TanAlp = -(xInt2 - xint) / (yInt2 - yint)
    alp = Atn(TanAlp)
    sina = Sin(alp)
    cosa = Cos(alp)
Dim xloc0#, yloc0#
    yloc0 = (y0 - yInt2) * cosa - (x0 - xInt2) * sina
    xloc0 = (y0 - yInt2) * sina + (x0 - xInt2) * cosa
Dim dxloc#
    dxloc = -Sqr(Dr * Dr / 4 - yloc0 * yloc0)
    
    xlocint = xloc0 - dxloc
    ylocint = 0
Dim xint3#, yint3#
    xint3 = xInt2 + xlocint * cosa - ylocint * sina
    yint3 = yInt2 + xlocint * sina + ylocint * cosa
'Set Gr = Grs.AddStar(xint3, yint3, 0)
Dim Gr2 As Graphic
    Set Gr2 = GrTeeth.Graphics.AddLineSingle(xInt2, yInt2, 0, xint3, yint3, 0)
    GrTeeth.Graphics.Remove Gr2.Index
    Grs.AddGraphic Gr2
    
' Add arc segment on Outsdide circle
Dim Gr3 As Graphic
    Set Gr3 = GrTeeth.Graphics.AddArcTriplePoint(xInt1, yInt1, 0, D0 / 2, 0, 0, xInt1, -yInt1, 0)
    GrTeeth.Graphics.Remove Gr3.Index
    Grs.AddGraphic Gr3

'add second evolvente curve as arc
Dim Gr4 As Graphic
    Set Gr4 = GrTeeth.Graphics.AddArcTriplePoint(xInt1, -yInt1, 0, xa, -ya, 0, xInt2, -yInt2, 0)
    GrTeeth.Graphics.Remove Gr4.Index
    Grs.AddGraphic Gr4

'Add the line segment
Dim Gr5 As Graphic
    Set Gr5 = GrTeeth.Graphics.AddLineSingle(xInt2, -yInt2, 0, xint3, -yint3, 0)
    GrTeeth.Graphics.Remove Gr5.Index
    Grs.AddGraphic Gr5
    
' Add Arc on Inside circle
Dim StepAngle#, AngleBottom#, Angl0#
    StepAngle = 2 * Pi / N
    Angl0 = Atn((yint3 - y0) / (xint3 - x0))
    AngleBottom = StepAngle - 2 * Atn((yint3 - y0) / (xint3 - x0))
Dim xMid#, yMid#, xk#, yk#
    xMid = x0 + Dr / 2 * Cos(-Angl0 - AngleBottom / 2)
    yMid = y0 + Dr / 2 * Sin(-Angl0 - AngleBottom / 2)
    xk = x0 + Dr / 2 * Cos(-Angl0 - AngleBottom)
    yk = y0 + Dr / 2 * Sin(-Angl0 - AngleBottom)
Dim Gr6 As Graphic
    Set Gr6 = GrTeeth.Graphics.AddArcTriplePoint(xint3, -yint3, 0, xMid, yMid, 0, xk, yk, 0)
    GrTeeth.Graphics.Remove Gr6.Index
    Grs.AddGraphic Gr6
Dim GrGroup As Graphic
    Set GrGroup = Grs.Add(imsiGroup)
    
Dim Gr1Dup As Graphic
Dim Gr2Dup As Graphic
Dim Gr3Dup As Graphic
Dim Gr4Dup As Graphic
Dim Gr5Dup As Graphic
Dim Gr6Dup As Graphic

    Set Gr1Dup = Gr1.Duplicate
    Set Gr2Dup = Gr2.Duplicate
    Set Gr3Dup = Gr3.Duplicate
    Set Gr4Dup = Gr4.Duplicate
    Set Gr5Dup = Gr5.Duplicate
    Set Gr6Dup = Gr6.Duplicate
    
    
Dim GrIndex As Long
    With GrGroup.Graphics
        GrIndex = Gr2Dup.Index
        Grs.Remove GrIndex
        .AddGraphic Gr2Dup
        
        GrIndex = Gr1Dup.Index
        Grs.Remove GrIndex
        .AddGraphic Gr1Dup
                
        GrIndex = Gr3Dup.Index
        Grs.Remove GrIndex
        .AddGraphic Gr3Dup
        
        GrIndex = Gr4Dup.Index
        Grs.Remove GrIndex
        .AddGraphic Gr4Dup
        
        GrIndex = Gr5Dup.Index
        Grs.Remove GrIndex
        .AddGraphic Gr5Dup
        
        GrIndex = Gr6Dup.Index
        Grs.Remove GrIndex
        .AddGraphic Gr6Dup

Dim i%
        For i = 2 To N
            Set Gr2Dup = Gr2.Duplicate
            Set Gr1Dup = Gr1.Duplicate
            Set Gr3Dup = Gr3.Duplicate
            Set Gr4Dup = Gr4.Duplicate
            Set Gr5Dup = Gr5.Duplicate
            Set Gr6Dup = Gr6.Duplicate
            
            fi = -StepAngle * (i - 1)
            
            Gr2Dup.RotateAxis fi, 0, 0, 1, x0, y0, z0
            Gr1Dup.RotateAxis fi, 0, 0, 1, x0, y0, z0
            Gr3Dup.RotateAxis fi, 0, 0, 1, x0, y0, z0
            Gr4Dup.RotateAxis fi, 0, 0, 1, x0, y0, z0
            Gr5Dup.RotateAxis fi, 0, 0, 1, x0, y0, z0
            Gr6Dup.RotateAxis fi, 0, 0, 1, x0, y0, z0
            
            GrIndex = Gr2Dup.Index
            Grs.Remove GrIndex
            .AddGraphic Gr2Dup
                
            GrIndex = Gr1Dup.Index
            Grs.Remove GrIndex
            .AddGraphic Gr1Dup
                    
            GrIndex = Gr3Dup.Index
            Grs.Remove GrIndex
            .AddGraphic Gr3Dup
            
            GrIndex = Gr4Dup.Index
            Grs.Remove GrIndex
            .AddGraphic Gr4Dup
            
            GrIndex = Gr5Dup.Index
            Grs.Remove GrIndex
            .AddGraphic Gr5Dup
            
            GrIndex = Gr6Dup.Index
            Grs.Remove GrIndex
            .AddGraphic Gr6Dup
        Next i
    End With
    
    Gr1.Deleted = True
    Gr2.Deleted = True
    Gr3.Deleted = True
    Gr4.Deleted = True
    Gr5.Deleted = True
    Gr6.Deleted = True
    GrTeeth.Deleted = True

Dim GrGearContour As Graphic
    Set GrGearContour = Grs.Add(, "TCW50Polyline")
    Call Polyline50(GrGroup, False, xint3, yint3, GrGearContour)
'MsgBox ("xcWorld=" & CStr(xcWorld) & "  ycWorld=" & CStr(ycWorld))
    GrGearContour.MoveRelative xcWorld, ycWorld, 0
'    GrGearContour.Properties("PenColor") = RGB(255, 0, 0)
    If GearWidth > 0 Then
        GrGearContour.Properties("Thickness") = GearWidth
        GrGearContour.Properties("Solid") = 1
    End If
    
    
    TCWViewRedraw
    
    Set Gr = Nothing
    Set Gr1 = Nothing
    Set Gr2 = Nothing
    Set Gr3 = Nothing
    Set Gr4 = Nothing
    Set Gr5 = Nothing
    Set Gr6 = Nothing
    Set GrTeeth = Nothing
    Set Gr1Dup = Nothing
    Set Gr2Dup = Nothing
    Set Gr3Dup = Nothing
    Set Gr4Dup = Nothing
    Set Gr5Dup = Nothing
    Set Gr6Dup = Nothing
    Set GrGroup = Nothing
    Set GrGearContour = Nothing
    
    
End Sub
Private Sub Polyline50(GrSel As Graphic, UnDirection As Boolean, xBeg0 As Double, yBeg0 As Double, GrRes As Graphic)

Dim Gr As Graphic
Dim Sel As Selection
Dim SelCount As Long
    SelCount = GrSel.Graphics.Count
Dim i As Long
Dim nV As Long, j As Long
Dim xV#, yV#
Dim xj#, yj#, zj#, xj1#, yj1#, zj1#
Dim GrType As String
Dim Vers As Vertices
Dim Ver0 As Vertex, Ver1 As Vertex, Ver2 As Vertex, Ver3 As Vertex
Dim VerIndex As Long
Dim VerIn As Long
        VerIn = -1
Dim xEnd#, yEnd#

'    Set GrRes = Grs.Add(, "TCW50Polyline")
    GrRes.Vertices.UseWorldCS = True
Dim hDr As Long ' Handle to active drawing
    hDr = TCWDrawingActive()
Dim GrIndex As Long
Dim hGr As Long
    GrIndex = GrRes.Index
    hGr = TCWGraphicAt(hDr, GrIndex)
Dim hVer As Long
'Dim ArcEnds(100) As Long, NumEnds As Long
' Dim PolyArc As ArcData
' Dim Icen As Long
' Dim DataArc(10)
 
    Set Gr = GrSel.Graphics(0)
    GrType = Gr.Type
'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
' GRAPHIC  GRAPHIC  GRAPHIC  GRAPHIC  GRAPHIC  GRAPHIC  GRAPHIC
    If GrType = "GRAPHIC" Then
        Set Vers = Gr.Vertices
        With Vers
            xj = .Item(0).x
            yj = .Item(0).y
            xj1 = .Item(1).x
            yj1 = .Item(1).y
            If Abs(xj - xBeg0) < Eps And Abs(yj - yBeg0) < Eps Then
                GrRes.Vertices.Add xj, yj, 0
                GrRes.Vertices.Add xj1, yj1, 0
                
                xEnd = xj1
                yEnd = yj1
            Else
                GrRes.Vertices.Add xj1, yj1, zj1
                GrRes.Vertices.Add xj, yj, zj

                xEnd = xj
                yEnd = yj
            End If
        End With
    End If
'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
' ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC
' Circle Arc
     
     If GrType = "ARC" Then
Dim xc#, yc#, x1#, y1#, x2#, y2#, R#, xMid#, yMid#, xDir#, yDir#
Dim Rot%
        Set Vers = Gr.Vertices
        With Vers
            x1 = .Item(1).x
            y1 = .Item(1).y
            x2 = .Item(2).x
            y2 = .Item(2).y
            xc = .Item(0).x
            yc = .Item(0).y
            xDir = .Item(3).x
            yDir = .Item(3).y
            
            R = Sqr((x1 - xc) * (x1 - xc) + (y1 - yc) * (y1 - yc))
            Rot = ArcRotation(x1, y1, xDir, yDir, xc, yc, R)
            Call ArcMiddlePoint(xc, yc, x1, y1, x2, y2, R, Rot, xMid, yMid)
            
            If Abs(x1 - xBeg0) < Eps And Abs(y1 - yBeg0) < Eps Then
                GrRes.Vertices.Add x1, y1, 0
                
                Set Ver0 = GrRes.Vertices.Add(xc, yc, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(xMid, yMid, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(x2, y2, 0)
                
                xEnd = x2
                yEnd = y2
            Else
                GrRes.Vertices.Add x2, y2, 0
                
                Set Ver0 = GrRes.Vertices.Add(xc, yc, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(xMid, yMid, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(x1, y1, 0)
            
                xEnd = x1
                yEnd = y1
            End If
        End With
    End If
    
'#####################################################################
'#####################################################################
'#####################################################################
    
    For i = 1 To SelCount - 1
        Set Gr = GrSel.Graphics(i)
'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
' GRAPHIC GRAPHIC GRAPHIC GRAPHIC GRAPHIC GRAPHIC GRAPHIC GRAPHIC
        If Gr.Type = "GRAPHIC" Then
            Set Vers = Gr.Vertices
            With Vers
                xj = .Item(0).x
                yj = .Item(0).y
                xj1 = .Item(1).x
                yj1 = .Item(1).y
                If Abs(xj - xEnd) < Eps And Abs(yj - yEnd) < Eps Then
                    GrRes.Vertices.Add xj1, yj1, 0
                    xEnd = xj1
                    yEnd = yj1
                Else
                    GrRes.Vertices.Add xj, yj, 0
                    xEnd = xj
                    yEnd = yj
                End If
            End With
        End If
'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
' ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC  ARC
         If Gr.Type = "ARC" Then
            
            Set Vers = Gr.Vertices
        With Vers
            x1 = .Item(1).x
            y1 = .Item(1).y
            x2 = .Item(2).x
            y2 = .Item(2).y
            xc = .Item(0).x
            yc = .Item(0).y
            xDir = .Item(3).x
            yDir = .Item(3).y
            
            R = Sqr((x1 - xc) * (x1 - xc) + (y1 - yc) * (y1 - yc))
            Rot = ArcRotation(x1, y1, xDir, yDir, xc, yc, R)
            
            Call ArcMiddlePoint(xc, yc, x1, y1, x2, y2, R, Rot, xMid, yMid)
            
            If Abs(x1 - xEnd) < Eps And Abs(y1 - yEnd) < Eps Then
                
                Set Ver0 = GrRes.Vertices.Add(xc, yc, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(xMid, yMid, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(x2, y2, 0)
                
                xEnd = x2
                yEnd = y2
            Else
                
                Set Ver0 = GrRes.Vertices.Add(xc, yc, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(xMid, yMid, 0)
                Ver0.Bulge = True
                
                Set Ver0 = GrRes.Vertices.Add(x1, y1, 0)
            
                xEnd = x1
                yEnd = y1
            End If
        End With
        End If

'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


    Next i
    If Abs(xBeg0 - xEnd) < Eps And Abs(yBeg0 - yEnd) < Eps Then
        GrRes.Closed = True
    End If
    
    GrRes.Update
'    GrRes.Select
    TCWUndoRecordStart hDr, "Add GearContour"
    GrIndex = GrRes.Index
    hGr = TCWGraphicAt(hDr, GrIndex)
    TCWUndoRecordAddGraphic hDr, hGr
    TCWUndoRecordEnd hDr
    GrSel.Deleted = True
    
'    Set GrArc1 = Nothing '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'    Set PicRes1 = Nothing '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    Set Ver0 = Nothing
    Set Ver1 = Nothing
    Set Ver2 = Nothing
    Set Ver3 = Nothing
    Set Vers = Nothing

    Set Gr = Nothing
    Set Sel = Nothing

End Sub
'This macros defines  index of all Polyline's arcs Middle points
Private Sub PolyLineArcCenterPoints(Gr As Graphic, PolyArc As ArcData)

Dim GrCosm As Graphic

Dim nV As Long, i As Long
Dim Vers As Vertices
Dim xi0#, yi0#, xi1#, yi1#, xi2#, yi2#, xi3#, yi3#

Dim nVCosm As Long, j As Long
Dim VersCosm As Vertices
Dim xj0#, yj0#, xj1#, yj1#
    Set Vers = Gr.Vertices
    Vers.UseWorldCS = True
    nV = Vers.Count
    PolyArc.NumCen = 0
    Set GrCosm = Gr.Graphics(0)
    Set VersCosm = GrCosm.Vertices
    nVCosm = VersCosm.Count
Dim j0 As Long
    j0 = 0
Dim VerBase As SelInfo
    VerBase.nV = nV
ReDim VerBase.xV(nV)
ReDim VerBase.yV(nV)
    With Vers
        For i = 0 To nV - 1
            VerBase.xV(i) = .Item(i).x
            VerBase.yV(i) = .Item(i).y
        Next i
    End With
    
    
Dim VerCosm As SelInfo
    VerCosm.nV = nVCosm
ReDim VerCosm.xV(nVCosm)
ReDim VerCosm.yV(nVCosm)
    With VersCosm
        For i = 0 To nVCosm - 1
            VerCosm.xV(i) = .Item(i).x
            VerCosm.yV(i) = .Item(i).y
        Next i
    End With
Dim k As Long, kMid As Long
Dim xMid#, yMid#

        i = 0
LBEG:
        xi0 = VerBase.xV(i)
        yi0 = VerBase.yV(i)
        xi1 = VerBase.xV(i + 1)
        yi1 = VerBase.yV(i + 1)
        For j = 0 To nVCosm - 2
            xj0 = VerCosm.xV(j)
            yj0 = VerCosm.yV(j)
            xj1 = VerCosm.xV(j + 1)
            yj1 = VerCosm.yV(j + 1)
            If Abs(xi0 - xj0) < Eps And Abs(yi0 - yj0) < Eps Then
                If Abs(xi1 - xj1) < Eps And Abs(yi1 - yj1) < Eps Then
                ' Line Segment
                    i = i + 1
                    If i = VerBase.nV - 1 Then
                        GoTo LEnd
                    Else
                        GoTo LBEG
                    End If
                Else
                ' Arc Segment
                    xi2 = VerBase.xV(i + 2)
                    yi2 = VerBase.yV(i + 2)
                    xi3 = VerBase.xV(i + 3)
                    yi3 = VerBase.yV(i + 3)
                    PolyArc.ArcCen(PolyArc.NumCen) = i + 1
 '                   NumEnds = NumEnds + 1
                    i = i + 3
                    For k = 0 To nVCosm - 1
                        xj0 = VerCosm.xV(k)
                        yj0 = VerCosm.yV(k)
                        If Abs(xi3 - xj0) < Eps And Abs(yi3 - yj0) < Eps Then
                            kMid = CLng((k + j) / 2)
                            xMid = VerCosm.xV(kMid)
                            yMid = VerCosm.yV(kMid)
                        End If
                    Next k
                    PolyArc.xMid(PolyArc.NumCen) = xMid
                    PolyArc.yMid(PolyArc.NumCen) = yMid
                    PolyArc.NumCen = PolyArc.NumCen + 1

                    If i = VerBase.nV - 1 Then
                        GoTo LEnd
                    Else
                        GoTo LBEG
                    End If
                End If
            End If
        Next j
LEnd:
    Set VersCosm = Nothing
    Set Vers = Nothing
    Set GrCosm = Nothing

End Sub


Sub TeethInvol()
Dim Gr As Graphic

Dim PressureAngle#  ' Pressure Angle
    PressureAngle = CDbl(frmGearContour.PressureAngle.Text) / 180 * Pi
Dim DiaPitch#   'Diametral Pitch
    DiaPitch = CDbl(frmGearContour.DiamPitch.Text)
Dim NumTeeth As Long 'Number of Teeth on Gear
    NumTeeth = 20
    NumTeeth = CInt(frmGearContour.TeethCount.Text)
    
Dim BulgePoly As Boolean
Dim GrGroup As Graphic
    If frmGearContour.Option1 = True Then
        BulgePoly = False
    Else
        BulgePoly = True
        Set GrGroup = Grs.Add(11)
    End If
    
Dim Rb#, R#, R0#, RR#, b#
    ' Rb - Base Circle Radius
    ' R - Pitch Radius
    ' R0 - Outside Radius
    ' RR - Root Radius
    ' b - Dedendum
    
    R = NumTeeth / (2 * DiaPitch)
'    R = 3
    Rb = R * Cos(PressureAngle)
    
    b = 1.25 / DiaPitch
    R0 = (NumTeeth + 2) / (2 * DiaPitch)
    RR = R - b
Dim xc#, yc#
    xc = xcWorld
    yc = ycWorld
    
'    Set Gr = Grs.AddCircleCenterAndPoint(xc, yc, 0, xc + R, yc, 0) 'Pitch Circle
'    Gr.Properties("PenColor") = RGB(255, 0, 0)
'    Gr.Draw
'    Set Gr = Grs.AddCircleCenterAndPoint(xc, yc, 0, xc + R0, yc, 0) 'Outside Circle
'    Gr.Properties("PenColor") = RGB(0, 255, 0)
'    Gr.Draw
'    Set Gr = Grs.AddCircleCenterAndPoint(xc, yc, 0, xc + Rb, yc, 0) 'Base Circle
'    Gr.Properties("PenColor") = RGB(0, 0, 255)
'    Gr.Draw
'    Set Gr = Grs.AddCircleCenterAndPoint(xc, yc, 0, xc + RR, yc, 0) 'Root Circle
'    Gr.Properties("PenColor") = RGB(0, 0, 0)
'    Gr.Draw
    
    
    ' Calculate points of involute
    
Dim fi#, dfi#, fi0#, fiE#, fiPrev#, fiNext#
    fi0 = 0
    dfi = Pi / 10000
Dim xi#, yi#, ri#, rNext#, rPrev#
    rPrev = Rb
    
    If RR > Rb Then ' Define fi0
        For fi = 0 To Pi / 2 Step dfi ' Define fiE
            xi = xc + Rb * (Cos(fi) + fi * Sin(fi))
            yi = yc + Rb * (Sin(fi) - fi * Cos(fi))
            ri = Sqr((xi - xc) * (xi - xc) + (yi - yc) * (yi - yc))
            If ri > RR Then
                rNext = ri
                fiNext = fi
                fiPrev = fiNext - dfi
                Exit For
            End If
            rPrev = ri
        Next fi
        fi0 = fiPrev + dfi * (RR - rPrev) / (rNext - rPrev)
    End If
    
    For fi = fi0 To Pi / 2 Step dfi ' Define fiE
        xi = xc + Rb * (Cos(fi) + fi * Sin(fi))
        yi = yc + Rb * (Sin(fi) - fi * Cos(fi))
        ri = Sqr((xi - xc) * (xi - xc) + (yi - yc) * (yi - yc))
        If ri > R0 Then
            rNext = ri
            fiNext = fi
            fiPrev = fiNext - dfi
            Exit For
        End If
        rPrev = ri
    Next fi
    fiE = fiPrev + dfi * (R0 - rPrev) / (rNext - rPrev)
    
Dim i As Long, nDiv As Long

    nDiv = 10
Dim xT() As Double
ReDim xT(nDiv)
Dim yT() As Double
ReDim yT(nDiv)

    dfi = (fiE - fi0) / nDiv
    For i = 0 To nDiv
        fi = fi0 + dfi * i
        xi = xc + Rb * (Cos(fi) + fi * Sin(fi))
        yi = yc + Rb * (Sin(fi) - fi * Cos(fi))
        xT(i) = xi
        yT(i) = yi
    Next i
    
'############################################################################
'############################################################################
' Approximate Involute as Arc
Dim xR#, yR#, xB#, yB#, xE#, yE#, L#, sina#, cosa#, xInt1#, yInt1#, xInt2#, yInt2#
Dim L1#, L2#
Dim iMax As Long, yLocInv#, yLocMax#
    If BulgePoly = True Then
        yLocMax = -100000000
        xB = xT(0)
        yB = yT(0)
        xE = xT(nDiv)
        yE = yT(nDiv)
        
        L = Sqr((xE - xB) ^ 2 + (yE - yB) ^ 2)
        sina = (yE - yB) / L
        cosa = (xE - xB) / L
        For i = 1 To nDiv - 1
            yLocInv = (yT(i) - yB) * cosa - (xT(i) - xB) * sina
            If Abs(yLocInv) > yLocMax Then
                yLocMax = Abs(yLocInv)
                iMax = i
            End If
        Next i
Dim GrInv0 As Graphic
        Set GrInv0 = Grs.AddArcTriplePoint(xT(0), yT(0), 0, xT(iMax), yT(iMax), 0, xT(nDiv), yT(nDiv), 0)
        GrInv0.Properties("PenColor") = RGB(255, 0, 0)
    End If
'############################################################################
'############################################################################

    ' Add line segment from involute to Root Circle
    If RR < Rb Then
        xB = xT(0)
        yB = yT(0)
        xE = xT(1)
        yE = yT(1)
        L = Sqr((xE - xB) * (xE - xB) + (yE - yB) * (yE - yB))
        sina = (yE - yB) / L
        cosa = (xE - xB) / L
        Call LineCircIntersection(xB, yB, sina, cosa, xc, yc, RR, xInt1, yInt1, xInt2, yInt2)
        L1 = Sqr((xInt1 - xB) * (xInt1 - xB) + (yInt1 - yB) * (yInt1 - yB))
        L2 = Sqr((xInt2 - xB) * (xInt2 - xB) + (yInt2 - yB) * (yInt2 - yB))
        If L1 > L2 Then
            xB = xInt2
            yB = yInt2
        Else
            xB = xInt1
            yB = yInt1
        End If
ReDim Preserve xT(nDiv + 1)
ReDim Preserve yT(nDiv + 1)
        For i = nDiv To 0 Step -1
            xT(i + 1) = xT(i)
            yT(i + 1) = yT(i)
        Next i
        xT(0) = xB
        yT(0) = yB
        nDiv = nDiv + 1
' #############################################################################
' #############################################################################
        If BulgePoly = True Then
        'Add First Line
Dim GrLine0 As Graphic
            Set GrLine0 = Grs.AddLineSingle(xT(0), yT(0), 0, xT(1), yT(1), 0)
            GrLine0.Properties("PenColor") = RGB(255, 0, 0)
        End If
' #############################################################################
' #############################################################################

    End If
    
    
    ' Add Bottom Arc Points
Dim CircPitch#  ' Circular Pitch
    CircPitch = 2 * Pi * R / NumTeeth
Dim AngPitch#
    AngPitch = 2 * Pi / NumTeeth
Dim Ang0#
    sina = (yT(0) - yc) / RR
    cosa = (xT(0) - xc) / RR
    Ang0 = Angle(sina, cosa)
Dim AngMid#, xMid#, yMid#, xiPrev#, yiPrev#, xiNext#, yiNext#
    dfi = Pi / 10000
    For fi = fi0 To Pi / 2 Step dfi ' Define fiE
        xi = xc + Rb * (Cos(fi) + fi * Sin(fi))
        yi = yc + Rb * (Sin(fi) - fi * Cos(fi))
        ri = Sqr((xi - xc) * (xi - xc) + (yi - yc) * (yi - yc))
        If ri > R Then
            rNext = ri
            xiNext = xi
            yiNext = yi
            Exit For
        End If
        rPrev = ri
        xiPrev = xi
        yiPrev = yi
    Next fi
    xMid = xiPrev + (xiNext - xiPrev) * (R - rPrev) / (rNext - rPrev)
    yMid = yiPrev + (yiNext - yiPrev) * (R - rPrev) / (rNext - rPrev)
    sina = (yMid - yc) / R
    cosa = (xMid - xc) / R
    AngMid = Angle(sina, cosa)
    If Ang0 > AngMid Then
        Ang0 = Ang0 - 2 * Pi
    End If
Dim Ang1#
    Ang1 = AngMid - AngPitch / 4
Dim ArcDiv As Long, j As Long
    ArcDiv = 2
    dfi = (Ang0 - Ang1) / ArcDiv
    For i = 1 To ArcDiv
        fi = Ang0 - i * dfi
        xi = xc + RR * Cos(fi)
        yi = yc + RR * Sin(fi)
ReDim Preserve xT(nDiv + 1)
ReDim Preserve yT(nDiv + 1)
        For j = nDiv To 0 Step -1
            xT(j + 1) = xT(j)
            yT(j + 1) = yT(j)
        Next j
        xT(0) = xi
        yT(0) = yi
        nDiv = nDiv + 1
    Next i
    
'##########################################################################
'##########################################################################
    If BulgePoly = True Then
        'Add Bottom arc
Dim GrArcBot As Graphic
        xB = xc + RR * Cos(Ang0)
        yB = yc + RR * Sin(Ang0)
        xMid = xc + RR * Cos(Ang1)
        yMid = yc + RR * Sin(Ang1)
        xE = xc + RR * Cos(Ang1 - Abs(Ang0 - Ang1))
        yE = yc + RR * Sin(Ang1 - Abs(Ang0 - Ang1))
            
        Set GrArcBot = Grs.AddArcTriplePoint(xB, yB, 0, xMid, yMid, 0, xE, yE, 0)
        GrArcBot.Properties("PenColor") = RGB(255, 0, 0)
        
        ' Duplicate Line and InvoluteCurve
Dim GrLine1 As Graphic
        Set GrLine1 = GrLine0.Duplicate
        GrLine1.RotateAxis Pi, Cos(Ang1), Sin(Ang1), 0, xc, yc, 0
Dim GrInv1 As Graphic
        Set GrInv1 = GrInv0.Duplicate
        GrInv1.RotateAxis Pi, Cos(Ang1), Sin(Ang1), 0, xc, yc, 0
    End If
'##########################################################################
'##########################################################################
    
    ' Add Top Arc Points
    sina = (yT(nDiv) - yc) / R0
    cosa = (xT(nDiv) - xc) / R0
    Ang0 = Angle(sina, cosa)
    Ang1 = AngMid + AngPitch / 4
    dfi = (Ang1 - Ang0) / ArcDiv
    For i = 1 To ArcDiv
        fi = Ang0 + i * dfi
        xi = xc + R0 * Cos(fi)
        yi = yc + R0 * Sin(fi)
ReDim Preserve xT(nDiv + 1)
ReDim Preserve yT(nDiv + 1)
        nDiv = nDiv + 1
        xT(nDiv) = xi
        yT(nDiv) = yi
    Next i
    
'##########################################################################
'##########################################################################
    If BulgePoly = True Then
        'Add Top arc
Dim GrArcTop As Graphic
        xB = xc + R0 * Cos(Ang0)
        yB = yc + R0 * Sin(Ang0)
        xMid = xc + R0 * Cos(Ang1)
        yMid = yc + R0 * Sin(Ang1)
        xE = xc + R0 * Cos(Ang1 + Abs(Ang0 - Ang1))
        yE = yc + R0 * Sin(Ang1 + Abs(Ang0 - Ang1))
        
        Set GrArcTop = Grs.AddArcTriplePoint(xB, yB, 0, xMid, yMid, 0, xE, yE, 0)
        GrArcTop.Properties("PenColor") = RGB(255, 0, 0)
        
        Grs.Remove GrInv1.Index
        GrGroup.Graphics.AddGraphic GrInv1
        
        Grs.Remove GrLine1.Index
        GrGroup.Graphics.AddGraphic GrLine1
        
        Grs.Remove GrArcBot.Index
        GrGroup.Graphics.AddGraphic GrArcBot
        
        Grs.Remove GrLine0.Index
        GrGroup.Graphics.AddGraphic GrLine0
        
        Grs.Remove GrInv0.Index
        GrGroup.Graphics.AddGraphic GrInv0
        
        Grs.Remove GrArcTop.Index
        GrGroup.Graphics.AddGraphic GrArcTop
        
        Set GrArcTop = Nothing
        Set GrInv0 = Nothing
        Set GrLine0 = Nothing
        Set GrLine1 = Nothing
        Set GrInv1 = Nothing
        Set GrArcBot = Nothing
   End If
'##########################################################################
'##########################################################################
    
'###########################################################################
' Define the bottom fillet
Dim x1#, y1#, x2#, y2#, x3#, y3#, rFillet#
Dim xLoc#, yLoc#, Bet#, sinb#, cosb#
    x1 = xT(1)
    y1 = yT(1)
    x2 = xT(2)
    y2 = yT(2)
    x3 = xT(3)
    y3 = yT(3)
    L1 = Sqr((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1))
    L2 = Sqr((x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2))
    If L2 > L1 Then
        rFillet = L1 / 2
    Else
        If L2 > L1 / 2 Then
            rFillet = L1 / 2
        Else
            rFillet = 0.8 * L2
        End If
    End If
    sina = (y1 - y2) / L1
    cosa = (x1 - x2) / L1
    yLoc = (y3 - y2) * cosa - (x3 - x2) * sina
    xLoc = (y3 - y2) * sina + (x3 - x2) * cosa
    sinb = Abs(yLoc) / L2
    cosb = Abs(xLoc) / L2
    Bet = Pi - Angle(sinb, cosb)
    xLoc = rFillet / Tan(Bet / 2)
    yLoc = rFillet
Dim xcFillet#, ycFillet#
    xcFillet = x2 + xLoc * cosa - yLoc * sina
    ycFillet = y2 + xLoc * sina + yLoc * cosa
Dim xLast#, yLast#, xFirst#, yFirst#
    yLoc = 0
    xLast = x2 + xLoc * cosa - yLoc * sina
    yLast = y2 + xLoc * sina + yLoc * cosa
    L1 = Sqr((x2 - xcFillet) * (x2 - xcFillet) + (y2 - ycFillet) * (y2 - ycFillet))
    sina = (y2 - ycFillet) / L1
    cosa = (x2 - xcFillet) / L1
    xLoc = rFillet
    yLoc = 0
    xMid = xcFillet + xLoc * cosa - yLoc * sina
    yMid = ycFillet + xLoc * sina + yLoc * cosa
    sina = (y3 - y2) / L2
    cosa = (x3 - x2) / L2
    xLoc = rFillet / Tan(Bet / 2)
    yLoc = 0
    xFirst = x2 + xLoc * cosa - yLoc * sina
    yFirst = y2 + xLoc * sina + yLoc * cosa
    
    xT(ArcDiv) = xFirst
    yT(ArcDiv) = yFirst
    
ReDim Preserve xT(nDiv + 1)
ReDim Preserve yT(nDiv + 1)
        For j = nDiv To 2 Step -1
            xT(j + 1) = xT(j)
            yT(j + 1) = yT(j)
        Next j
        xT(ArcDiv) = xMid
        yT(ArcDiv) = yMid
        nDiv = nDiv + 1
ReDim Preserve xT(nDiv + 1)
ReDim Preserve yT(nDiv + 1)
        For j = nDiv To 2 Step -1
            xT(j + 1) = xT(j)
            yT(j + 1) = yT(j)
        Next j
        xT(ArcDiv) = xLast
        yT(ArcDiv) = yLast
        nDiv = nDiv + 1
    
    
'###########################################################################
' Form theProfile for Single Teeth
ReDim Preserve xT(2 * nDiv)
ReDim Preserve yT(2 * nDiv)
Dim nDiv0 As Long
    nDiv0 = nDiv
    xi = xT(nDiv)
    yi = yT(nDiv)
    ri = Sqr((xi - xc) * (xi - xc) + (yi - yc) * (yi - yc))
    sina = (yi - yc) / ri
    cosa = (xi - xc) / ri
    fi0 = Angle(sina, cosa)

    For i = nDiv0 - 1 To 0 Step -1
        xi = xT(i)
        yi = yT(i)
        ri = Sqr((xi - xc) * (xi - xc) + (yi - yc) * (yi - yc))
        sina = (yi - yc) / ri
        cosa = (xi - xc) / ri
        fi = Angle(sina, cosa)
        If fi > Pi Then
            fi = fi - 2 * Pi
        End If
        dfi = fi - fi0
        dfi = -dfi
        fi = fi0 + dfi
        xi = xc + ri * Cos(fi)
        yi = yc + ri * Sin(fi)
        nDiv = nDiv + 1
        xT(nDiv) = xi
        yT(nDiv) = yi
    Next i
    ' Polar cordinate for single Teeth
Dim fiT() As Double
Dim rT() As Double
ReDim fiT(2 * nDiv)
ReDim rT(2 * nDiv)
    For i = 0 To nDiv
        xi = xT(i)
        yi = yT(i)
        ri = Sqr((xi - xc) * (xi - xc) + (yi - yc) * (yi - yc))
        sina = (yi - yc) / ri
        cosa = (xi - xc) / ri
        fi = Angle(sina, cosa)
        fiT(i) = fi
        rT(i) = ri
    Next i
    
    nDiv0 = nDiv
ReDim Preserve xT(2 * nDiv * NumTeeth)
ReDim Preserve yT(2 * nDiv * NumTeeth)
ReDim Preserve fiT(2 * nDiv * NumTeeth)
ReDim Preserve rT(2 * nDiv * NumTeeth)
    
    
    For i = 1 To NumTeeth - 1
        dfi = AngPitch * i
        For j = 1 To nDiv0
            ri = rT(j)
            fi = fiT(j)
            fi = fi + dfi
            xi = xc + ri * Cos(fi)
            yi = yc + ri * Sin(fi)
            nDiv = nDiv + 1
            xT(nDiv) = xi
            yT(nDiv) = yi
        Next j
    Next i
    
    
    If BulgePoly = False Then
        Set Gr = Grs.Add(imsiPolyline)
        With Gr.Vertices
            For i = 0 To nDiv - 1
                xi = xT(i)
                yi = yT(i)
                .Add xi, yi, 0
            Next i
            .AddClose
        End With
    End If
'#####################################################################
'#####################################################################
    If BulgePoly = True Then
        ' Add Full Gear contour as couple of Arcs and lines
Dim GrGroupCount As Long
        GrGroupCount = GrGroup.Graphics.Count
Dim GrDup As Graphic
        With GrGroup.Graphics
            For i = 1 To NumTeeth - 1
                dfi = AngPitch * i
                For j = 0 To GrGroupCount - 1
                    Set GrDup = .Item(j).Duplicate
                    GrDup.RotateAxis dfi, 0, 0, 1, xc, yc, 0
                    .Remove GrDup.Index
                    .AddGraphic GrDup
                Next j
            Next i
        End With
Dim xBeg0#, yBeg0#
        Set GrDup = GrGroup.Graphics(0)
        xBeg0 = GrDup.Vertices(2).x
        yBeg0 = GrDup.Vertices(2).y
        
        
Dim GrGearContour As Graphic
        Set GrGearContour = Grs.Add(, "TCW50Polyline")
        Call Polyline50(GrGroup, False, xBeg0, yBeg0, GrGearContour)
        
        Set GrDup = Nothing
        Set GrGroup = Nothing
    End If
    If frmGearContour.Check1.Value = 1 Then
        FileWrite = False
        frmSaveFile.Show 1
        If FileWrite = True Then
Dim FilePath$
            FilePath = frmSaveFile.PathFile
            Open FilePath For Output As #1
Dim nV As Long
Dim Str$
            If BulgePoly = True Then
                With GrGearContour.Graphics(0).Vertices
                    nV = .Count
                    Str = "Gear Contour"
                    Print #1, Str
                    Str = "Point count = " & CStr(nV)
                    Print #1, Str
                    For i = 0 To nV - 1
                        xi = .Item(i).x
                        yi = .Item(i).y
                        Str = "G1" & "X" & Format(xi, "###0.0000") & "Y" & Format(yi, "###0.0000")
                        Print #1, Str
                    Next i
                End With
            Else
                With Gr.Vertices
                    nV = .Count
                    Str = "Gear Contour"
                    Print #1, Str
                    Str = "Point count = " & CStr(nV)
                    Print #1, Str
                    For i = 0 To nV - 1
                        xi = .Item(i).x
                        yi = .Item(i).y
                        Str = "G1" & "X" & Format(xi, "###0.0000") & "Y" & Format(yi, "###0.0000")
                        Print #1, Str
                    Next i
                End With
            End If
            Close #1
        End If
    End If
    
    Set GrGearContour = Nothing

'#####################################################################
'#####################################################################
End Sub
Private Function LineCircIntersection(x1 As Double, y1 As Double, sina As Double, cosa As Double, xc As Double, yc As Double, R As Double, xInt1 As Double, yInt1 As Double, xInt2 As Double, yInt2 As Double) As Boolean
Dim xcLoc#, ycLoc#
    xcLoc = (yc - y1) * sina + (xc - x1) * cosa
    ycLoc = (yc - y1) * cosa - (xc - x1) * sina
    If Abs(ycLoc) > Abs(R) + Eps Then
        LineCircIntersection = False
        Exit Function
    End If
Dim t#
    t = Sqr(Abs(R * R - ycLoc * ycLoc))
Dim xLoc#, yLoc#
    yLoc = 0
    xLoc = xcLoc + t
    xInt1 = x1 + xLoc * cosa - yLoc * sina
    yInt1 = y1 + xLoc * sina + yLoc * cosa

    xLoc = xcLoc - t
    xInt2 = x1 + xLoc * cosa - yLoc * sina
    yInt2 = y1 + xLoc * sina + yLoc * cosa
    LineCircIntersection = True
End Function

Private Function Angle(sinb As Double, cosb As Double) As Double

        If Abs(cosb) < 0.0001 Then
            If sinb > 0 Then
                Angle = Pi / 2
            Else
                Angle = 3 * Pi / 2
            End If
        Else
            If sinb >= 0 And cosb > 0 Then Angle = Atn(sinb / cosb)
            If sinb >= 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb > 0 Then Angle = 2 * Pi + Atn(sinb / cosb)
        End If
End Function


' Define the middle point of Base Arc
' from Beg-End Points and Rot
' Rot=1 - Counter Clockwise
' Rot=-1 - Clockwise
Private Sub ArcMiddlePoint(xc As Double, yc As Double, xB As Double, yB As Double, xE As Double, yE As Double, R As Double, Rot As Integer, xMid As Double, yMid As Double)
    If Abs(R) < Eps Then
        xMid = xc
        yMid = yc
        Exit Sub
    End If

Dim sina#, cosa#
Dim fiBeg#, fiEnd#, fiMid#
    sina = (yB - yc) / R
    cosa = (xB - xc) / R
    fiBeg = Angle(sina, cosa)
    
    sina = (yE - yc) / R
    cosa = (xE - xc) / R
    fiEnd = Angle(sina, cosa)
    
    If Rot = 1 Then ' Counter Clockwise
        If fiBeg > fiEnd Then fiEnd = fiEnd - 2 * Pi
    Else    'Clockwise
        If fiBeg < fiEnd Then fiEnd = fiEnd - 2 * Pi
    End If

    fiMid = (fiBeg + fiEnd) / 2
    xMid = xc + R * Cos(fiMid)
    yMid = yc + R * Sin(fiMid)
    

End Sub

' Define the direction of Arc rotation
' return ArcRotation = 1 if CounterClockwise
' return ArcRotation = -1 if Clockwise

Private Function ArcRotation(xB As Double, yB As Double, xDir As Double, yDir As Double, xc As Double, yc As Double, R As Double) As Integer
Dim sina#, cosa# ', Alp0#, Alp1#
    sina = (yB - yc) / R
    cosa = (xB - xc) / R
Dim xLoc#, yLoc#
    xLoc = (yDir - yc) * sina + (xDir - xc) * cosa
    yLoc = (yDir - yc) * cosa - (xDir - xc) * sina
    If yLoc > 0 Then
        ArcRotation = 1
    Else
        ArcRotation = -1
    End If
End Function

